package simplelog

import (
	"fmt"
	"os"
	"testing"
	"time"
)

func TestLog(t *testing.T) {
	log := NewLog()

	log2 := NewLog(
		WithWriter(os.Stdout),
		WithTimeFormat("2006-01-02"),
		WithLogFormat("%-10s %s %v %s =-=-> %s\n"),
		WithLogFlag(FlagInfo|FlagWarn|FlagError),
	)

	fmt.Printf("simpleLog => %#v\n", log)

	fmt.Println("=========================================================")

	for i := 0; i < 5; i++ {
		log.Debug("测试 Debug 输出")
		time.Sleep(100 * time.Millisecond)
	}

	fmt.Println("=========================================================")

	for i := 0; i < 5; i++ {
		log2.Debug("测试 Debug 输出")
		log2.Error("测试 Error 输出")
		time.Sleep(100 * time.Millisecond)
	}
}
